//"ekspDKCenFK.sc","Eksport DK do Centrali i FK","\Eksport\",0,2.0.0,SYSTEM
/////////////////////////////////////////
// "Eksport DK do Centrali i FK"
// ekspDKCenFK.sc
/////////////////////////////////////////

// mapa dokumentow "do wyeksportowania"
// ( pozniejszy import wymaga zachowania kolejnosci wg ID w przypadku korekt zbiorczych )
MapValue ToExport
ToExport.Type( Long )

// korekty wpisane do w.w. mapy beda eksportowane osobno z zachowaniem kolejnosci wg ID
// ( pomijamy lancuch korekt konkretnego dokumentu )
#define SKIP_INVOICE_CORRECTION

#include "Eksport do FK - include"
#include "Eksport dokumentw (nowych) - include"

int DECLARE PrintError(String msg)

int Sub BeginProcess(int iFlagi, int iCzyPytac)
	if iCzyPytac then
		io.SetField("__CzyPytac", "TAK")
	else
		io.SetField("__CzyPytac", "NIE")
	endif

	int iVal

	//////////////////////////////////////////
	// odczyt parametrw wywoania raportu
	if (iFlagi & 0x80) then
		//parametry przekazane w argumentach wywoania funkcji
		iNieEkspOznak = iFlagi & 0x1
		iOznaczaj = iFlagi & 0x2
		iDokumentZbiorczy = iFlagi & 0x20
		iDekretyZbiorcze = iFlagi & 0x40
		iRownoKsiegMag = iFlagi & 0x4
	else
		//czytaj z pliku - domylnie
		iVal = Val(GetIni(eksport.GetIniSectionName(), "IgnorujZaznacz", eksport.GetFirmIni()))
		iNieEkspOznak = iVal & 0x1
		iOznaczaj = iVal & 0x2
		iDokumentZbiorczy = iVal & 0x20
		iDekretyZbiorcze = iVal & 0x40
		iRownoKsiegMag = iVal & 0x4
	endif

	// mapa dokumentow do wyeksportowania - przygotuj od poczatku dla nowego eksportu
	ToExport.Clear()

	EksportINFO()
EndSub

// przygotowanie mapy wszystkich dokumentow powiazanych z biezacym dokumentem :
// - dokument oryginalny
// - lancuch korekt
// - dokumenty korygowane zbiorczo
// - lancuch korekt dokumentow korygowanych zbiorczo

Int Sub DoProcessPrepare( Long idDK )

	Dispatch xConnected, xDoc
	Int      ind
	String   keyFormat = "%010d"		// format klucza ID w postaci stringu

	xDoc = GetObjById( "BDokumentSp", idDK )
	If !xDoc Then 
		PrintError( Using "Brak w bazie DK rekordu o id = %d", idDK )
	EndIf
	DoProcessPrepare = IIF( !xDoc, 0, 1 )

	If DoProcessPrepare && ToExport.Index( Using keyFormat, idDK ) == 0 Then
		// brak dokumentu w mapie - dopisujemy
		ToExport.Set( ( Using keyFormat, idDK ), idDK )

		If xDoc.CzyKZ Then
			// korekta zbiorcza - dopisujemy dokumenty korygowane zbiorczo i ich lancuchy korekt 
			xConnected = xDoc.dokumentyKorygowaneKZ
		Else
			// dokument oryginalny lub pojedyncza korekta - dopisujemy dokumenty z lancucha korekt
			xConnected = xDoc.dokumentZKorektami
		EndIf
		For ind = 1 To ind > xConnected.Count || !DoProcessPrepare
			DoProcessPrepare = IIF( DoProcessPrepare( xConnected.Item( ind ).id ), DoProcessPrepare, 0 )
		Next ind
	EndIf

EndSub

Int Sub DoProcessBody( Long idDK )
	DoProcessBody = 1

	long nRes

	Dispatch xDokumentSp 
	nRes = !(xDokumentSp=GetObjById("BDokumentSp",idDK))
	if nRes then PrintError(Using "Brak w bazie DK rekordu o id= %d", idDK)

	DoProcessBody = WypelnijEksportRec_Dk(xDokumentSp)

EndSub

int Sub DoProcess()

	Long     idDk = eksport.GetId()
	Dispatch xDokumentSp = GetObjById( "BDokumentSp", idDK )
	If !xDokumentSp Then PrintError( Using "Brak w bazie DK rekordu o id = %d", idDK )

	DoProcess = EksportujDkDoFk( xDokumentSp )

	If DoProcess Then
		// mapa dokumentow do wyeksportowania - dopisz wszystkie dokumenty powiazane z biezacym dokumentem
		DoProcess = DoProcessPrepare( idDk )
	EndIf

EndSub

int Sub EndProcess()

	Int  ind

	EndProcess = 1

	// przygotowane dokumenty eksportujemy w kolejnosci wg ID
	ToExport.Sort()

	For ind = 1 To ind > ToExport.Size() || !EndProcess
		EndProcess = IIF( DoProcessBody( ToExport.Get( ind ) ), EndProcess, 0 )
	Next ind

	ToExport.Clear()

EndSub

