EXEC(N'ALTER VIEW [HM].[PurchaseCardIndexView] 
AS 
SELECT
	 DK.id,
	 [Common].[GetCardIndexMarkSymbol](CAST(DK.znacznik as int)) as Tag,
	 DK.guid as DKGuid,
	 dir.path as Catalog,
	 DK.aktywny as Active,
	 CAST(DK.anulowany AS BIT) AS Cancelled,
	 DK.typ as Type,
	 DK.kod As Code,
	 DK.nazwa As NameDok,
	 DK.seria As SeriesDoc,
	 DK.typ_dk As TypeDoc,
	 DK.khid as KhID,
	 DK.magazyn as Store,
	 DK.opis As Description,
	 DK.wystawil as IssuePersonID,
	 DK.khadid as CustomerAdrressID,
	 DK.exp_fk as ExportFK,
	 DK.flag as Flag,
	 DK.iddokkoryg as DocCorrectID,
	 DK.rr as Settlement,
	 DK.subtyp as SubType,
	 --DK.anulowany as Cancel,
	 DK.schemat as Scheme,
	 DK.datawplywu as ReceiptDate,
	 DK.statusRDF as StatusFK,
	 DK.data As DateDoc,
	 DK.data_obcy As DateDocForeign,
	 DK.plattermin as DatePayment,
	 DK.kod_obcy AS NumberForeign,
	 DK.datasp as PurchaseDate,
	 DK.netto * (-1) as Netto,
	 DK.vat * (-1) as VAT,
	 DK.walNetto * (-1) as ValueNetto,
	 (DK.netto+DK.vat) * (-1) as Value,
	 DK.walBrutto * (-1) as ValueBrutto,
	 DK.jpk as JPK,
	 DK.jpk_V7 as JPK_V7,
	 DK.waluta As Currency,
	 DK.ok as SettlementMoney,
	 DK.odid as CustomerID,
	 DK.rozlmg as DeliveryWarehouse,
	 DK.eFaktura as eInvoice,	 
	 isnull(dir.path,''\'') AS CatalogPath,
     DK.rodzaj as KindId,
     Kinds.kod as KindName
	,ISNULL(TR.status,0) AS trStatus,
	CASE
		WHEN  DK.statusRDF = 0 THEN ''brak faktury''
		WHEN  DK.eFaktura = 1 THEN ''e-Faktura''
		WHEN  DK.eFaktura = 0 THEN ''faktura papierowa''
		ELSE ''''
	END AS InvoiceKind,
	CASE WHEN DK.ok = 0 or DK.bufor = 1 THEN ''nierozliczony''
		 ELSE ''rozliczony''
	END AS StatusPayoff,
	CASE WHEN ISNULL(TR.status,32) < 32 AND DK.rr < 2 THEN ''nierozliczony'' 
		 ELSE ''rozliczony'' 
		 END as SettledInWarehouse,
	CASE WHEN DK.bufor = 0 THEN   
			''wystawione''             
         ELSE
            ''w buforze''
	END as Buffer,
	CASE	WHEN (DK.flag&8192 & 8192) = 0 THEN '''' 
			ELSE ''K'' 
	END AS Correction,
	CASE DK.statusRDF
		WHEN 0 THEN ''brak dokumentu''
		WHEN 1 THEN ''dokument bez PDF''
		WHEN 2 THEN ''dokument z PDF'' END AS DocRepository
	,CASE DK.exp_fk%2 when 1 then ''wyeksportowany'' Else ''niewyeksportowany'' end as Export
	,ISNULL(TR.flag,0) AS trFlag
	,ISNULL(KH.kod,'''') AS DepartmentCode
	,ISNULL(US.LoginName,'''') AS PersonCode
	,ISNULL(UsrRights.UserId,'''') AS UserId
	,ISNULL(SSCommon.vKh.kod,'''') AS KhCode
	,ISNULL(AD.nazwa,'''') AS KhName
	,ISNULL(vKh1.kod,'''') AS SupplierCode
	,ISNULL(AD1.nazwa,'''') AS SupplierName
	,DK.datarej AS InRegisterDate
	,PC.*
FROM HM.DK 
LEFT JOIN HM.KH ON KH.id = DK.magazyn 
LEFT JOIN SScommon.HMF_PurchasingInvoiceClassification PC on PC.ElementId = DK.id
LEFT JOIN SSCommon.STUsers as US ON DK.wystawil = US.id 
LEFT JOIN SSCommon.vKh ON SSCommon.vKh.id = DK.khid 
LEFT JOIN SSCommon.vKh vKh1 ON vKh1.Id = DK.Odid
LEFT JOIN HM.AD AD1 ON AD1.id = DK.Odadid
LEFT JOIN HM.DK AS Kinds ON DK.rodzaj = Kinds.id
LEFT JOIN HM.AD ON AD.id = DK.khadid 
LEFT JOIN HM.TR ON (TR.owner_id = CASE WHEN DK.iddokkoryg IS NULL THEN DK.id ELSE DK.iddokkoryg END) AND TR.owner_base=34 AND TR.typ=1
INNER JOIN HM.AppUserDepartments UsrRights ON UsrRights.DepartmentId=DK.magazyn
LEFT JOIN hm.Directories dir ON dir.id=dk.katalog
WHERE DK.typ=202    
')
