﻿EXEC(N'ALTER VIEW [HM].[SaleDocumentsCardIndexView] 
AS 
SELECT
	DK.id,
	DK.guid AS DKGuid,
	isnull(dir.path,''\'') AS CatalogPath,
	DK.aktywny AS IsActive,
	DK.typ AS Type,
	DK.kod AS Code,
	[Common].[GetCardIndexMarkSymbol](CAST(DK.znacznik AS INT)) AS Tag,
	DK.nazwa AS NameDoc,
	DK.seria AS SeriesDoc,
	DK.typ_dk AS TypeDoc,
	DK.datasp AS DateSale, 
    Dk.dataZest1 AS DateIssue,
	DK.khid AS KhID,
	DK.magazyn AS Store,
	DK.opis AS Description,
	DK.wystawil AS IssuePersonID,
	DK.odebrane AS Customer,
	DK.khadid AS CustomerAdrressID,
	DK.exp_fk AS ExportFK,
	DK.statusFK AS StstusFK,
	DK.flag AS Flag,
	CASE WHEN (DK.flag&8192 & 8192) = 0 THEN '''' ELSE ''K'' END AS Correction,
	CASE WHEN DK.ok = 0 OR DK.bufor = 1  THEN ''nierozliczony''
			ELSE ''rozliczony'' END AS StatusPayoff,	
	DK.subtyp AS SubType,
	DK.schemat AS Scheme,
	CASE DK.statusRDF WHEN 0 THEN ''brak dokumentu'' 
					  WHEN 1 THEN ''dokument bez PDF''
					  WHEN 2 THEN ''dokument z PDF'' END AS DocRepository,
	DK.data AS DateDoc,
	DK.plattermin AS DatePayment,
	DK.netto AS Netto,
	DK.vat AS VAT,
	DK.walNetto AS ValueNetto,
	(DK.netto+DK.vat) AS Value,
	DK.walBrutto AS ValueGross,
	DK.jpk AS JPK,
	DK.jpk_V7 AS JPK_V7,
	DK.waluta AS Currency,
	CASE WHEN DK.bufor = 0 THEN   
			''wystawione''             
         ELSE
            ''w buforze''
	END AS Buffer,
	CAST(CASE WHEN DK.anulowany = 0 THEN 0 ELSE 1 END AS BIT) AS Canceled,
	CAST(CASE WHEN DK.ok = 0 THEN 0 ELSE 1 END AS BIT) AS SettledInCash,
    CAST(CASE WHEN ISNULL(trans.status,32) < 32 AND DK.rr < 2 THEN ''Nie'' ELSE ''Tak'' END AS VARCHAR(3)) AS SettledInWarehouse,
	DK.odid AS CustomerID,
	DK.rozlmg AS DeliveryWarehouse,
	DK.eFaktura AS eInvoice,
	InvoiceKind = CASE
		   WHEN  DK.statusRDF = 0 THEN ''brak faktury''
		   WHEN  DK.eFaktura = 1 THEN ''e-Faktura''
		   WHEN  DK.eFaktura = 0 THEN ''faktura papierowa''
		   ELSE '''' END,
    DK.rodzaj AS KindId,
    Kinds.kod AS KindName,	
	CASE DK.exp_fk%2 WHEN 1 THEN ''wyeksportowany'' ELSE ''niewyeksportowany'' END AS Export,
	CASE ((DK.exp_fk/2)/2%2) WHEN 1 THEN ''F'' ELSE '''' END AS Fiscalization
,ISNULL(trans.status,0) AS trStatus
,ISNULL(trans.flag,0) AS trFlag
,ISNULL(KH.kod,'''') AS DepartmentCode
,ISNULL(SU.LoginName,'''') AS PersonKod
,ISNULL(UsrRights.UserId,'''') AS UserId
,ISNULL(Skh.kod,'''') AS khKod 
,ISNULL(skod.kod,'''') AS khOd 
,ISNULL(AD.nazwa,'''') AS khName 
,dk.splitPayment
,DK.datarej AS InRegisterDate
,SC.*
FROM HM.dk AS dk
LEFT JOIN HM.KH ON KH.id = DK.magazyn 
LEFT JOIN SScommon.HMF_SalesInvoiceClassification SC ON SC.ElementId = DK.id
LEFT JOIN SSCommon.STUsers SU ON DK.wystawil = SU.id	
LEFT JOIN SSCommon.vKh SKh ON dk.khid = Skh.id
LEFT JOIN SSCommon.vKh Skod ON dk.odid = Skod.id
LEFT JOIN HM.SalesKinds AS Kinds ON DK.rodzaj = Kinds.KindId
LEFT JOIN HM.AD ON AD.id = DK.khadid 	
INNER JOIN HM.AppUserDepartments UsrRights ON UsrRights.DepartmentId=DK.magazyn
LEFT JOIN HM.TR trans ON (trans.owner_id = CASE WHEN DK.iddokkoryg IS NULL THEN DK.id ELSE DK.iddokkoryg END) AND TRans.owner_base=16 AND TRans.typ=1
LEFT JOIN HM.Directories dir ON dir.id=dk.katalog
WHERE DK.typ=0  
')

EXEC(N'ALTER VIEW [HM].[SaleDocumentsCardIndexWithoutTrView] 
AS 
SELECT
	DK.id,
	DK.guid AS DKGuid,
	isnull(dir.path,''\'') AS CatalogPath,
	DK.aktywny AS IsActive,
	DK.typ AS Type,
	DK.kod AS Code,
	[Common].[GetCardIndexMarkSymbol](CAST(DK.znacznik AS INT)) AS Tag,
	DK.nazwa AS NameDoc,
	DK.seria AS SeriesDoc,
	DK.typ_dk AS TypeDoc,
	DK.datasp AS DateSale, 
    Dk.dataZest1 AS DateIssue,
	DK.khid AS KhID,
	DK.magazyn AS Store,
	DK.opis AS Description,
	DK.wystawil AS IssuePersonID,
	DK.odebrane AS Customer,
	DK.khadid AS CustomerAdrressID,
	DK.exp_fk AS ExportFK,
	DK.statusFK AS StstusFK,
	DK.flag AS Flag,
	CASE WHEN (DK.flag&8192 & 8192) = 0 THEN '''' ELSE ''K'' END AS Correction,
	CASE WHEN DK.ok = 0 OR DK.bufor = 1  THEN ''nierozliczony''
			   ELSE ''rozliczony'' END AS StatusPayoff,	
	DK.subtyp AS SubType,
	DK.schemat AS Scheme,
	CASE DK.statusRDF WHEN 0 THEN ''brak dokumentu''
					  WHEN 1 THEN ''dokument bez PDF''
					  WHEN 2 THEN ''dokument z PDF'' END AS DocRepository,
	DK.data AS DateDoc,
	DK.plattermin AS DatePayment,
	DK.netto AS Netto,
	DK.vat AS VAT,
	DK.walNetto AS ValueNetto,
	(DK.netto+DK.vat) AS Value,
	DK.walBrutto AS ValueGross,
	DK.jpk AS JPK,
	DK.JPK_V7 AS JPK_V7,
	DK.waluta AS Currency,
	CASE WHEN DK.bufor = 0 THEN   
			''wystawione''             
         ELSE
            ''w buforze''
	END AS Buffer,
	CAST(CASE WHEN DK.anulowany = 0 THEN 0 ELSE 1 END AS BIT) AS Canceled,
	CAST(CASE WHEN DK.ok = 0 THEN 0 ELSE 1 END AS BIT) AS SettledInCash,
	DK.odid AS CustomerID,
	DK.rozlmg AS DeliveryWarehouse,
	DK.eFaktura AS eInvoice,
	InvoiceKind = CASE
		   WHEN  DK.statusRDF = 0 THEN ''brak faktury''
		   WHEN  DK.eFaktura = 1 THEN ''e-Faktura''
		   WHEN  DK.eFaktura = 0 THEN ''faktura papierowa''
		   ELSE '''' END,
    DK.rodzaj AS KindId,
    Kinds.kod AS KindName,	
	CASE DK.exp_fk%2 WHEN 1 THEN ''wyeksportowany'' ELSE ''niewyeksportowany'' END AS Export,
	CASE ((DK.exp_fk/2)/2%2) WHEN 1 THEN ''F'' ELSE '''' END AS Fiscalization
,ISNULL(KH.kod,'''') AS DepartmentCode
,ISNULL(SU.LoginName,'''') AS PersonKod
,ISNULL(UsrRights.UserId,'''') AS UserId
,ISNULL(Skh.kod,'''') AS khKod 
,ISNULL(skod.kod,'''') AS khOd 
,ISNULL(AD.nazwa,'''') AS khName
,dk.splitPayment
,DK.datarej AS InRegisterDate
,SC.*
FROM HM.dk AS dk
LEFT JOIN HM.KH ON KH.id = DK.magazyn 
LEFT JOIN SScommon.HMF_SalesInvoiceClassification SC ON SC.ElementId = DK.id
LEFT JOIN SSCommon.STUsers SU ON DK.wystawil = SU.id	
LEFT JOIN SSCommon.vKh SKh ON dk.khid = Skh.id
LEFT JOIN SSCommon.vKh Skod ON dk.odid = Skod.id
LEFT JOIN HM.SalesKinds AS Kinds ON DK.rodzaj = Kinds.KindId
LEFT JOIN HM.AD ON AD.id = DK.khadid 	
INNER JOIN HM.AppUserDepartments UsrRights ON UsrRights.DepartmentId=DK.magazyn
LEFT JOIN HM.Directories dir ON dir.id=dk.katalog
WHERE DK.typ=0  
')
