﻿ALTER PROCEDURE HM.hm_Jpk_CreateTempFaktury
	@typDaty	SMALLINT,
	@dataOd		DATE,
	@dataDo		DATE,
	@subtyp		INT,
	@waluta		VARCHAR( 10 ),
	@JpkRaport	INT,
	@docID		INT				-- operacje w tabeli tymczasowej "W" (##JpkFakturyWybrane) i "F" (##JpkFaktury) dla biezacego @@SPID
									--   -2 - wyczysc dotychczasowa zawartosc tabel "W" i "F"
									--   -1 - tabela "W" juz przygotowana
									--        przygotuj tabele "F" na podstawie wybranych dokumentow z tabeli "W"
									--    0 - przygotuj tabele "F" niezaleznie od zawartosci tabeli "W"
									--  > 0 - tabela "W" w trakcie przygotowania (dodaj ID kolejnego wybranego dokumentu)
AS
BEGIN
	-- A local temporary table created in a stored procedure is dropped automatically when the stored procedure completes !!!
	-- Using GLOBAL temporary table !!!
	IF ( SELECT OBJECT_ID( 'tempdb..##JpkFakturyWybrane' ) ) IS NULL
		CREATE TABLE ##JpkFakturyWybrane ( spid SMALLINT, id INT )
	ELSE
		IF ( @docID IN ( -2, 0 ) )
			DELETE FROM ##JpkFakturyWybrane WHERE spid = @@SPID

	IF ( SELECT OBJECT_ID( 'tempdb..##JpkFaktury' ) ) IS NULL
		CREATE TABLE ##JpkFaktury ( spid SMALLINT, id INT )
	ELSE
		DELETE FROM ##JpkFaktury WHERE spid = @@SPID

	IF @docID > 0
		INSERT INTO ##JpkFakturyWybrane
		SELECT @@SPID, @docID

	IF @docID = -2 OR @docID > 0
		RETURN

	SELECT @waluta = LTRIM( RTRIM( @waluta ) )
	SELECT @waluta = CASE WHEN UPPER( @waluta ) = 'PLN'    THEN ''							-- brak waluty
						  WHEN UPPER( @waluta ) = 'FC_PLN' THEN SUBSTRING( @waluta, 4, 3 )	-- zdefiniowana waluta PLN
						  ELSE                                  @waluta						-- inna waluta
					 END

	INSERT
	  INTO	##JpkFaktury
	SELECT	@@SPID, DK.id
	  FROM	DK
			LEFT OUTER JOIN ##JpkFakturyWybrane AS W ON DK.id = W.id AND W.spid = @@SPID
														-- data SP		data ZK
	 WHERE	CASE @typDaty	WHEN 1 THEN data			-- wystawienia	wprowadzenia
							WHEN 2 THEN datasp			-- sprzedazy	zakupu
							WHEN 4 THEN datawplywu		--				wplywu
							WHEN 5 THEN datarej			-- wejscia do rejestru
							WHEN 8 THEN data_obcy		--				dokumentu obcego
							ELSE		'0000-00-00'
			END BETWEEN @dataOd AND @dataDo
			AND subtyp = @subtyp AND anulowany = 0 AND bufor = 0 AND aktywny = 1 AND ( waluta = @waluta OR @JpkRaport IN ( 1, 2 ) ) AND jpk > 0
			AND ( W.id IS NOT NULL OR @docID = 0 )
END